//
// Copyright (C) 2006, NinjaTrader LLC <ninjatrader@ninjatrader.com>.
// NinjaTrader reserves the right to modify or overwrite this NinjaScript component with each release.
//

#region Using declarations
using System;
using System.ComponentModel;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Xml.Serialization;
using NinjaTrader.Data;
using NinjaTrader.Gui.Chart;
#endregion

#region NinjaScript generated code. Neither change nor remove.
// This namespace holds all indicators and is required. Do not change it.
namespace NinjaTrader.Indicator
{
    public partial class Indicator : IndicatorBase
    {
        private SymmetryDots[] cacheSymmetryDots = null;

        private static SymmetryDots checkSymmetryDots = new SymmetryDots();

        /// <summary>
        /// SymmetryIndicators.com SymmetryDots lines. v1.0
        /// </summary>
        /// <returns></returns>
        public SymmetryDots SymmetryDots(int barsBack, int numCloses, int numTicks, int pivotStrength)
        {
            return SymmetryDots(Input, barsBack, numCloses, numTicks, pivotStrength);
        }

        /// <summary>
        /// SymmetryIndicators.com SymmetryDots lines. v1.0
        /// </summary>
        /// <returns></returns>
        public SymmetryDots SymmetryDots(Data.IDataSeries input, int barsBack, int numCloses, int numTicks, int pivotStrength)
        {
            if (cacheSymmetryDots != null)
                for (int idx = 0; idx < cacheSymmetryDots.Length; idx++)
                    if (cacheSymmetryDots[idx].BarsBack == barsBack && cacheSymmetryDots[idx].NumCloses == numCloses && cacheSymmetryDots[idx].NumTicks == numTicks && cacheSymmetryDots[idx].PivotStrength == pivotStrength && cacheSymmetryDots[idx].EqualsInput(input))
                        return cacheSymmetryDots[idx];

            lock (checkSymmetryDots)
            {
                checkSymmetryDots.BarsBack = barsBack;
                barsBack = checkSymmetryDots.BarsBack;
                checkSymmetryDots.NumCloses = numCloses;
                numCloses = checkSymmetryDots.NumCloses;
                checkSymmetryDots.NumTicks = numTicks;
                numTicks = checkSymmetryDots.NumTicks;
                checkSymmetryDots.PivotStrength = pivotStrength;
                pivotStrength = checkSymmetryDots.PivotStrength;

                if (cacheSymmetryDots != null)
                    for (int idx = 0; idx < cacheSymmetryDots.Length; idx++)
                        if (cacheSymmetryDots[idx].BarsBack == barsBack && cacheSymmetryDots[idx].NumCloses == numCloses && cacheSymmetryDots[idx].NumTicks == numTicks && cacheSymmetryDots[idx].PivotStrength == pivotStrength && cacheSymmetryDots[idx].EqualsInput(input))
                            return cacheSymmetryDots[idx];

                SymmetryDots indicator = new SymmetryDots();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                indicator.BarsBack = barsBack;
                indicator.NumCloses = numCloses;
                indicator.NumTicks = numTicks;
                indicator.PivotStrength = pivotStrength;
                Indicators.Add(indicator);
                indicator.SetUp();

                SymmetryDots[] tmp = new SymmetryDots[cacheSymmetryDots == null ? 1 : cacheSymmetryDots.Length + 1];
                if (cacheSymmetryDots != null)
                    cacheSymmetryDots.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cacheSymmetryDots = tmp;
                return indicator;
            }
        }
    }
}

// This namespace holds all market analyzer column definitions and is required. Do not change it.
namespace NinjaTrader.MarketAnalyzer
{
    public partial class Column : ColumnBase
    {
        /// <summary>
        /// SymmetryIndicators.com SymmetryDots lines. v1.0
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.SymmetryDots SymmetryDots(int barsBack, int numCloses, int numTicks, int pivotStrength)
        {
            return _indicator.SymmetryDots(Input, barsBack, numCloses, numTicks, pivotStrength);
        }

        /// <summary>
        /// SymmetryIndicators.com SymmetryDots lines. v1.0
        /// </summary>
        /// <returns></returns>
        public Indicator.SymmetryDots SymmetryDots(Data.IDataSeries input, int barsBack, int numCloses, int numTicks, int pivotStrength)
        {
            return _indicator.SymmetryDots(input, barsBack, numCloses, numTicks, pivotStrength);
        }
    }
}

// This namespace holds all strategies and is required. Do not change it.
namespace NinjaTrader.Strategy
{
    public partial class Strategy : StrategyBase
    {
        /// <summary>
        /// SymmetryIndicators.com SymmetryDots lines. v1.0
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.SymmetryDots SymmetryDots(int barsBack, int numCloses, int numTicks, int pivotStrength)
        {
            return _indicator.SymmetryDots(Input, barsBack, numCloses, numTicks, pivotStrength);
        }

        /// <summary>
        /// SymmetryIndicators.com SymmetryDots lines. v1.0
        /// </summary>
        /// <returns></returns>
        public Indicator.SymmetryDots SymmetryDots(Data.IDataSeries input, int barsBack, int numCloses, int numTicks, int pivotStrength)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.SymmetryDots(input, barsBack, numCloses, numTicks, pivotStrength);
        }
    }
}
#endregion
